.586
.model flat,stdcall 
option casemap:none 
include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\user32.inc 
include \masm32\m32lib\masm32.inc 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib
includelib \masm32\m32lib\masm32.lib

.data 
align 16
  brt    dd  32 dup (0)  ; really use 512+1 bytes
  brm    dd  32 dup (0)  ;
  bsp    db 512 dup (0)  ; 1024 bits  512 bytes  4 bytes/byte 2,2,2,2 : 8
  bdd    dd  32 dup (0)  ; 1024 bits  128 bytes 32 dwords
  jbd    dd  31
  jbr    dd  16   ; (jbd / 2) + 1
  jbs    dd 127   ; (jbd+1 * 4) - 1  
;;  jbd    dd   1   ; 0..jbd dwords  0 : 4 bytes, 1 : 8 bytes
;;  jbr    dd   1   ; (jbd / 2) + 1
;;  jbs    dd   7   ; (jbd+1 * 4) - 1
  k      dd   0
  ksp    dd   0
  zsp    dd   0
  j      dd   0
  exact  dd   0

    

  szCaption  db "(Unsigned) Integer Square Root with Remainder",0 
  szFmtStr   db "%lu iterations",0
  szHexStr   db "0123456789ABCDEF000",0
  szBuffer   db  32 dup (0), 13, 10
  szbddlbl   db "Number  "
  szbdd      db 256 dup (0), 13, 10, 0, 0
  szbrtlbl   db "Root    "
  szbrt      db 256 dup (0), 13, 10, 0, 0
  szbrmlbl   db "Remainder   "
  szbrm      db 256 dup (0), 13, 10, 0, 0

; Bug fixes
;
; The original wasn't using the result of the brt < brm so it never
; did  brm - (brt + 1), brt + 2 so time was too low 2:37 (157 seconds)
;
;
; Additions
;
; Displays bdd, brt, brm in hex at program conclusion.
;
;
; Optimizations
;
; Tiny/quick code (single dword data) does the first 30 iterations, 
; instead of the full size code. Saves 25 seconds
;
; 
;   
;   Large Integer Square Root
;
;
; This program takes a Large Unsigned Integer 
; and calculates the Integer Square Root and Remainder.
;
; Does 1 Million square root calculations in 3:10 seconds of CPU time.
; 1.2 Ghz AMD Athlon 32 bit CPU using Windows XP.
;
; Did 3:35 before, the 30 iterations using the tiny code brought it
; down to 3:10.
;
; The routine can scale to various size integers 
; by adjusting the size of the main variables 
; and the variables that record their sizes.
;
;
; bdd the Number itself       x bytes or  x/4 dwords
; bsp the Number spread out   2 bits at a time    
;                           bsp 76 54 32 10  in 4 bytes
;                           bdd 76543210     in 1 byte
; brt the Root
; brm the Remainder
;
; jbd number of dwords 0 based bdd   ie 32 dwords  0..31  so jbd == 31
; jbr number of dwords 0 based br?   both brt and brm  (jbd div 2) + 1
;
; jbs number of dwords 0 based bsp   is also the number of bytes of bdd
;
; ksp number of bytes used by bsp
; k   loop counter to use each byte of bsp
;
; j   counter
; exact  flag  1 if an exact Square Root ie No remainder,  0 otherwise
;
; It can also detect when the root is exact  ie Square Root 10 for 100
;
;
;   Fairly close Delphi/Pascal code using a 16 bit / 2 byte number.
;   The sp filling routine is the only difference, 
;   The MASM code doesn't shift, pulls in place.
;
;   dd := 65535;                        (* 16 bit number     *)
;   rm := 0;
;   rt := 0;
;   for i := 0 to 7 do                  (* 0 to (bits / 2)-1 *)
;     sp[i] := (dd shr (i*2)) and 3;    (* 2 bits at a time  *)
; 
;   for i := 7 downto 0 do begin
;     rt :=  (rt shl 1);                (* rt * 2            *)
;     rm :=  (rm shl 2) + sp[i];        (* rm * 4  +  sp[i]  *)
; 
;     if (rt <  rm) then begin
;       rm := rm - rt - 1;
;       rt := rt + 2;
;     end;
;   end;
;   rt := rt shr 1;                     (* rt / 2  when done *)
;
;   exact := 0;
;   if rm = 0) and (rt*rt = dd) then
;     exact := 1;
;
;   writeln('Number    : ',dd);
;   writeln('Root      : ',rt);
;   writeln('Remainder : ',rm);
;
; 






.code 
start:

;;  jmp skipit   ; bypass the fill with random bytes, do tiny test

; 
; bdd  initialize with a fixed set of bytes
; 

  mov esi, 0
  .repeat
     mov eax, 3589713
     invoke nrandom, eax
     mov byte ptr [bdd+esi], al
     inc esi
  .until esi > 127    ; db 127 hi of dd


; 
; bdd  zero the low dword, set the high byte to Fx
; 

  mov bdd, 0
  or  byte ptr [bdd+127], 240

; 
; 
; 


; 
; vars  init with tiny values for debugging
; 

skipit:
;;  mov bdd, 295977617   ; 4334*4334 == 11A44291         ; 152399025
;;  mov jbd, 1           ; 0..jbd dwords  0 : 4 bytes, 1 : 8 bytes
;;  mov jbr, 1           ; (jbd / 2) + 1
;;  mov jbs, 7           ; (jbd+1 * 4) - 1


; 
; bdd  hex output display in messagebox
; 
 
 ;   mov esi, jbs
 ;   mov edi, 0
 ;   xor edx, edx
 ;   xor ecx, ecx
 ;   xor ebx, ebx  ; not needed
 ;   xor eax, eax
 ;   .while (jbs >= esi) && (esi >= 0)
 ;      mov dl, byte ptr [bdd+esi]
 ;      mov al, dl
 ;      shr al, 4
 ;      mov cl, [szHexStr+eax]
 ;      mov [szbdd+edi], cl
 ;      inc edi
 ;      mov al, dl
 ;      and al, 15
 ;      mov cl, [szHexStr+eax]
 ;      mov [szbdd+edi], cl
 ;      inc edi
 ;      dec esi
 ;   .endw
 ;   invoke MessageBox, NULL, addr szbddlbl, addr szCaption, MB_OK

; 
; Do a test of 1,000,000 iterations of Integer Square Root
; 

  .while (bdd < 1000000) ; 1000000)

;-  .while (exact < 1)
;-  mov exact, 1

; 
; brt brm  zero them out
; 

  mov ecx, jbr     ; 31 max   Use 16  which covers 65 bytes
  xor eax, eax
  .repeat
     mov [brt+ecx*4], eax
     mov [brm+ecx*4], eax
  .untilcxz
  mov brt, eax
  mov brm, eax

; 
; bsp  zero it    Can be skipped because it will overwrite during fill
; 

 ;   mov ecx, jbs  ; 0 to 127 dd,  0 to 511 db  
 ;   xor eax, eax
 ;   .repeat
 ;      mov dword ptr [bsp+ecx*4], eax
 ;   .untilcxz
 ;   mov dword ptr bsp, eax

; 
; bsp  fill it with  bdd  two bits at a time
; 

  xor esi, esi  ; 0 to 127 max
  xor edi, edi  ; 0 to 511 max
  xor eax, eax
  .repeat
    mov dl, byte ptr [bdd+esi]

    mov al, dl
;    shr al, 0
    and al, 3
    mov [bsp+edi], al
    inc edi

    mov al, dl
    shr al, 2
    and al, 3
    mov [bsp+edi], al
    inc edi

    mov al, dl
    shr al, 4
    and al, 3
    mov [bsp+edi], al
    inc edi

    mov al, dl
    shr al, 6    ; could shl 2 then use ah instead
;    and al, 3
    mov [bsp+edi], al
    inc edi

    inc esi
  .until esi > jbs  ; for every 1 byte of bdd, 4 bytes of bsp
  dec edi

; 
; adjust  ksp to highest byte in bsp with value > 0
; 

  .if [bsp+edi] == 0
     dec edi
    .if [bsp+edi] == 0
       dec edi
       .if [bsp+edi] == 0
          dec edi
       .endif
    .endif
  .endif
  mov ksp, edi
  mov k, edi


; 
 ;   if ksp < 30
 ;     zsp := 0;
 ;   else
 ;     zsp := ksp - 29
 ;
 ;     for k := ksp downto zsp begin
 ;       shl brt, 1
 ;       shl brm, 2
 ;       .if brt < brm
 ;          mov edx, brt
 ;          inc edx
 ;          sub brm, edx
 ;          add brm, 2
 ;       .endif
 ;     end;
 ;
 ;   if ksp < 30
 ;     k := -1;

; 
; for k = ksp downto 0
; 

;  mov ecx, ksp
  mov ecx, edi    ; ecx will hold k in the tiny routine

; 0:03:35 before  0:03:10 after (with tiny for 30 iterations)

  .if ecx < 30     ; ksp < 30
     mov zsp, 0
  .else
     mov edx, ecx  ; edx, ksp
     sub edx, 29
     mov zsp, edx
  .endif   

  .while (ksp >= ecx) && (ecx >= zsp)   ; for k := ksp downto zsp do begin
     shl brt, 1
     shl brm, 2
     mov al, [bsp+ecx]
     add byte ptr brm, al    ; or  byte ptr brm, al
     mov edx, brt
     .if edx < brm
        ; mov edx, brt
        inc edx
        sub brm, edx
        add brt, 2 
     .endif
     dec ecx   ; dec k
  .endw
  mov k, ecx

  .if ksp < 30
     ; shr brt, 1       ; don't do div 2 here   done later
     mov k, 0ffffffffh
  .endif

  .while  k < 0fffffff0h   ; ? maybe ?   sdword ptr k >= 0 

; 
; brt * 2
; 

  mov edx, jbr
  dec edx
  mov ecx, jbr
  .repeat
     mov  eax, [brt+edx*4]
     shld [brt+ecx*4], eax, 1
     dec  edx
  .untilcxz
  shl brt, 1

; 
; brm * 4   + bsp[k]
; 

  mov edx, jbr
  dec edx
  mov ecx, jbr
  .repeat
     mov  eax, [brm+edx*4]
     shld [brm+ecx*4], eax, 2
     dec  edx
  .untilcxz
  shl brm, 1

  mov ecx, k
  mov al, [bsp+ecx]
  add byte ptr brm, al   ; brm 7..2  bsp[k] 1..0
;  or  byte ptr brm, al

; 
; compare  brt with brm    > = <   3, 2, 1
; 

  mov eax, 2         ; eax instead of j
  mov ecx, jbr
  inc ecx
  mov edx, jbr
  .repeat
    mov esi, [brt+edx*4]
    mov edi, [brm+edx*4]
    .if esi > edi
       mov eax, 3
    .elseif esi < edi
       mov eax, 1
    .endif
  .untilcxz (eax != 2)
;  mov eax, j

; 
; brm = brm - brt - 1
; 

  .if eax == 1
    mov esi, 0
    stc
    .repeat
      mov eax, [brt+esi*4]
      sbb [brm+esi*4], eax
      inc esi
    .until esi > jbr
  
; 
; brt = brt + 2
; 

    add brt, 2
  .endif
  
; 
; endfor
; 

    dec k
  .endw


; 
; brt / 2   Square root calc almost done just scale down brt (shr 1)
; 

  mov edx, 0
  mov ecx, 1
  .while edx <= jbr
     mov  eax, [brt+ecx*4]
     shrd [brt+edx*4], eax, 1
     inc  edx
     inc  ecx
  .endw


; 
; Is it an exact SQUARE ROOT ?
; 

  mov exact, 0
  xor edx, edx
  mov eax, brt
  mul brt
  .if (eax == bdd)
     xor edx, edx
     xor eax, eax
     add eax, brm+0
     adc edx, 0
     add eax, brm+4
     adc edx, 0
     add eax, brm+8
     adc edx, 0
     add eax, brm+12
     adc edx, 0
   ;  mov dword ptr szbrtlbl, 20202020h      ; exact, 0
     .if (edx == 0) && (eax == 0)

        mov exact, 1
        mov dword ptr szbrtlbl, 54525153h
        mov esi, jbs
        inc esi
        shr esi, 1
      ;  dec esi
        mov edi, 0
        xor edx, edx
        xor ecx, ecx
      ;  xor ebx, ebx  ; not needed
        xor eax, eax
        .while (jbs >= esi) && (esi >= 0)
           mov dl, byte ptr [brt+esi]
           mov al, dl
           shr al, 4
           mov cl, [szHexStr+eax]
           mov [szbrt+edi], cl
           inc edi
           mov al, dl
           and al, 15
           mov cl, [szHexStr+eax]
           mov [szbrt+edi], cl
           inc edi
           dec esi
        .endw
        invoke MessageBox, NULL, addr szbrtlbl, addr szCaption, MB_OK
      
        mov esi, jbs
        inc esi
        shr esi, 1
      ;  dec esi
        mov edi, 0
        xor edx, edx
        xor ecx, ecx
      ;  xor ebx, ebx  ; not needed
        xor eax, eax
        .while (jbs >= esi) && (esi >= 0)
           mov dl, byte ptr [brm+esi]
           mov al, dl
           shr al, 4
           mov cl, [szHexStr+eax]
           mov [szbrm+edi], cl
           inc edi
           mov al, dl
           and al, 15
           mov cl, [szHexStr+eax]
           mov [szbrm+edi], cl
           inc edi
           dec esi
        .endw
        invoke MessageBox, NULL, addr szbrmlbl, addr szCaption, MB_OK

     .endif
  .endif

; 
; increment the iterations loop
; 

    inc bdd  ; low dword of bdd doing double duty as loop var
  .endw

; 
; 
; 


; 
; 
; 


  invoke wsprintf,addr szBuffer,addr szFmtStr, bdd
  invoke MessageBox, NULL, addr szBuffer, addr szCaption, MB_OK

  mov esi, jbs
  mov edi, 0
  xor edx, edx
  xor ecx, ecx
;  xor ebx, ebx  ; not needed
  xor eax, eax
  .while (jbs >= esi) && (esi >= 0)
     mov dl, byte ptr [bdd+esi]
     mov al, dl
     shr al, 4
     mov cl, [szHexStr+eax]
     mov [szbdd+edi], cl
     inc edi
     mov al, dl
     and al, 15
     mov cl, [szHexStr+eax]
     mov [szbdd+edi], cl
     inc edi
     dec esi
  .endw
  invoke MessageBox, NULL, addr szbddlbl, addr szCaption, MB_OK

  mov esi, jbs
  inc esi
  shr esi, 1
;  dec esi
  mov edi, 0
  xor edx, edx
  xor ecx, ecx
;  xor ebx, ebx  ; not needed
  xor eax, eax
  .while (jbs >= esi) && (esi >= 0)
     mov dl, byte ptr [brt+esi]
     mov al, dl
     shr al, 4
     mov cl, [szHexStr+eax]
     mov [szbrt+edi], cl
     inc edi
     mov al, dl
     and al, 15
     mov cl, [szHexStr+eax]
     mov [szbrt+edi], cl
     inc edi
     dec esi
  .endw
  invoke MessageBox, NULL, addr szbrtlbl, addr szCaption, MB_OK

  mov esi, jbs
  inc esi
  shr esi, 1
;  dec esi
  mov edi, 0
  xor edx, edx
  xor ecx, ecx
;  xor ebx, ebx  ; not needed
  xor eax, eax
  .while (jbs >= esi) && (esi >= 0)
     mov dl, byte ptr [brm+esi]
     mov al, dl
     shr al, 4
     mov cl, [szHexStr+eax]
     mov [szbrm+edi], cl
     inc edi
     mov al, dl
     and al, 15
     mov cl, [szHexStr+eax]
     mov [szbrm+edi], cl
     inc edi
     dec esi
  .endw
  invoke MessageBox, NULL, addr szbrmlbl, addr szCaption, MB_OK

  invoke ExitProcess, NULL 
end start